//更新頁
MqttJsonGroupUpdatePage.prototype._SaveGlobalVariable_ = function(Row)
{
	var Class = new StepFlow();
	Class.LockAllUi();
	var ssocket = io.connect(), Index=0, Length=Row.length;
	Row.eq(Index).find(".Button").click();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
		if(Row.eq(Index).find(".Message").is(":visible") == true && 
		   Row.eq(Index).find(".Message").css("color") == "rgb(34, 119, 0)")//成功
		{
			Index++;
			Row.eq(Index).find(".Button").click();
			ssocket.emit("BackgroundExecution");
			if(Index==Length)
			{
				ssocket.emit("SocketClose");
				MqttJsonGroupUpdatePage.prototype._ShowFirstPage_();
				Class.UnLockAllUi();
			}
		}
		else if(Index<Length)
		{
			ssocket.emit("BackgroundExecution");
		}
	});
}

MqttJsonGroupUpdatePage.prototype._IsSaveGlobalVariable_ = async function() {
    let Return = false;
    const Class = new LoadFile();

    try {
        const remoteBroker = await Class.ReadFile("./File/IoT_Platform/RemoteBroker.json", new Array());
        if (JSON.stringify(remoteBroker) === JSON.stringify(Global_RemoteBroker)) {
            Return = true;
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }

    return Return;
};


/* MqttJsonGroupUpdatePage.prototype._IsSaveGlobalVariable_ = function()
{
	var Return=false;
	var Class = new LoadFile();
	var RemoteBroker = Class.ReadFile("./File/IoT_Platform/RemoteBroker.json", new Array());
	
	if(JSON.stringify(RemoteBroker)==JSON.stringify(Global_RemoteBroker))
	{
		Return=true;
	}
	return Return;
}
 */
MqttJsonGroupUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	MqttJsonGroupFirstPage.prototype._Initialization_();
}

MqttJsonGroupUpdatePage.prototype._Initialization_ = async function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(await MqttJsonGroupUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		MqttJsonGroupUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	MqttJsonGroupUpdatePage.prototype._SaveGlobalVariable_(Row);
}




















//第1頁
MqttJsonGroupFirstPage.prototype._Initialization_ = function()
{
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
}

MqttJsonGroupFirstPage.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
}

MqttJsonGroupFirstPage.prototype._SaveFinished_ = function(that, ssocket)
{
	ssocket.emit("SaveFinished");
	ssocket.on("SaveFinished", function (Return) {
		if(Return == true)
		{
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(1).show();
		}
		ssocket.emit("SocketClose");
	});
}

MqttJsonGroupFirstPage.prototype._SaveStart_ = function(that, ssocket)
{
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
	if(Return == true)
	{
		var Callback0 = function(){MqttJsonGroupFirstPage.prototype._SaveFinished_(that, ssocket);}
		
		var JsonString1 = JSON.stringify(Global_RtuToMqttJsonVariable);
		var Callback1 = function(){MqttJsonGroupFirstPage.prototype._TransmissionJson_(ssocket, "SaveRtuToMqttJsonVariable", JsonString1, Callback0);}
		
		var JsonString2 = JSON.stringify(Global_TcpToMqttJsonVariable);
		var Callback2 = function(){MqttJsonGroupFirstPage.prototype._TransmissionJson_(ssocket, "SaveTcpToMqttJsonVariable", JsonString2, Callback1);}
		
		var JsonString3 = JSON.stringify(Global_AsciiToMqttJsonVariable);
		var Callback3 = function(){MqttJsonGroupFirstPage.prototype._TransmissionJson_(ssocket, "SaveAsciiToMqttJsonVariable", JsonString3, Callback2);}
		
		var JsonString4 = JSON.stringify(Global_MqttJsonGroup);
		
		$(that).closest('.Row').find(".Message").hide();
		$(that).closest('.Row').find(".Loading").show();
		MqttJsonGroupFirstPage.prototype._TransmissionJson_(ssocket, "SaveMqttJsonGroup", JsonString4, Callback3);
	}
	});
}
 
MqttJsonGroupFirstPage.prototype._SaveButton_ = function(that)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").hide();
	var ssocket = io.connect();
	MqttJsonGroupFirstPage.prototype._SaveStart_(that, ssocket);
}

MqttJsonGroupFirstPage.prototype._AutomaticGroupName_ = function()
{
	var Table = $("#Main_Center-Content").find(".Body").eq(1).find(".Table").eq(0);
	var Index = 1;
	var object = jQuery.parseJSON(JSON.stringify(Global_MqttJsonGroup));
	var number = Object.keys(object);
	var Name, NameArray=new Array();
	for(var i=0; i<number.length; i++)
	{
		NameArray.push(object[number[i]]["Name"]);
	}
	while(true)
	{
		Name = "Name"+Index;
		if(NameArray.indexOf(Name) == -1)
		{
			break;
		}
		Index++;
	}
	Table.find(".Row").eq(1).find(".Text").val(Name);
}

MqttJsonGroupFirstPage.prototype._RemoveRtuToMqttJsonGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_RtuToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_RtuToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

MqttJsonGroupFirstPage.prototype._RemoveTcpToMqttJsonGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_TcpToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_TcpToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

MqttJsonGroupFirstPage.prototype._RemoveAsciiToMqttJsonGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_AsciiToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_AsciiToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

MqttJsonGroupFirstPage.prototype._RemoveGroup_ = function(number)
{
	var GroupName = Global_MqttJsonGroup[number]["Name"];
	Global_MqttJsonGroup[number] = null;	delete Global_MqttJsonGroup[number];
	
	MqttJsonGroupFirstPage.prototype._RemoveRtuToMqttJsonGroupName_(GroupName);
	MqttJsonGroupFirstPage.prototype._RemoveTcpToMqttJsonGroupName_(GroupName);
	MqttJsonGroupFirstPage.prototype._RemoveAsciiToMqttJsonGroupName_(GroupName);
}

MqttJsonGroupFirstPage.prototype._InitialMqttJsonGroupObject_ = function(that)
{
	var number = Object.keys(Global_MqttJsonGroup);
	if(number.length == 0)
	{
		number=1;
	}
	else if(number.length>0)
	{
		number = Math.max.apply(null,number)+1;
	}
	if(typeof(Global_MqttJsonGroup[number]) == "undefined")
	{
		Global_MqttJsonGroup[number] = new Object();
		Global_MqttJsonGroup[number]["Name"] = $(that).closest(".Row").find(".Column").eq(2).find(".Text").val();		
		Global_MqttJsonGroup[number]["ScanRate"] = 1000;
		Global_MqttJsonGroup[number]["DeadBand"] = 0;
		Global_MqttJsonGroup[number]["WillTopic"] = "";
		Global_MqttJsonGroup[number]["Will"] = "";
		Global_MqttJsonGroup[number]["MqttConnection"] = new Array("Broker (Local)");		
		Global_MqttJsonGroup[number]["PublishTopic"] = "/"+$(that).closest(".Row").find(".Column").eq(2).find(".Text").val()+"/Publish";
		Global_MqttJsonGroup[number]["PublishQos"] = 2;
		Global_MqttJsonGroup[number]["SubscribeTopic"] = "/"+$(that).closest(".Row").find(".Column").eq(2).find(".Text").val()+"/Subscribe";
		Global_MqttJsonGroup[number]["SubscribeQos"] = 2;
		Global_MqttJsonGroup[number]["Retain"] = 0;
	}
}

MqttJsonGroupFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var TableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+TableId).find(".DynamicRow");
	Element.prop("checked",Bool);
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").click();
		}
	}
}

MqttJsonGroupFirstPage.prototype._GetAllNumber_ = function()
{
	var ObjectKey = Object.keys(Global_MqttJsonGroup);
	return ObjectKey;
}

MqttJsonGroupFirstPage.prototype._IsTickedGroup_ = function()
{
	var Return=false;
	var Id = "#GroupTable";
	if($(Id).find(".DynamicRow").find(":checked").length >0)
	{
		Return=true;
	}
	return Return;
}

MqttJsonGroupFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	$("#GroupTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#GroupToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#GroupTable").append(html);
		$("#GroupTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#GroupTable").find(".DynamicRow").eq(index).find(".Column").eq(2).text(Global_MqttJsonGroup[ObjectKey[i]]["Name"]);
		index++;
	}
}

MqttJsonGroupFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#GroupToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

MqttJsonGroupFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 5;
	var ObjectKey = MqttJsonGroupFirstPage.prototype._GetAllNumber_();
	MqttJsonGroupFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	MqttJsonGroupFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#GroupTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

MqttJsonGroupFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#GroupToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
}

MqttJsonGroupFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#GroupToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
}

MqttJsonGroupFirstPage.prototype._CheckGroupName_ = function(that)
{
	var Id = "#GroupTable";
	$(Id).find(".Message").hide();
	var Row=$(Id).find(".Row");
	var Name = Row.eq(1).find(".Text").val();
	var Class = new Type();
	if(Class.EnglishDigitalAndBottomline(Name) == false)
	{
		Row.eq(0).find(".Message").eq(0).show();
	}
	
	if(MqttJsonGroupFirstPage.prototype._IsNameRepeat_(Name) == true)
	{
		Row.eq(0).find(".Message").eq(1).show();
	}
}

MqttJsonGroupFirstPage.prototype._EditButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
	var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	var Name=$(that).closest(".DynamicRow").find(".Column").eq(2).text();

	$("#Main_Center-Content").find(".Body").eq(2).show();
	$("#Main_Center-Content").css("border-left-width", "0px");
	//$("#Main_Center-Content").css("width", "100%");
	//$("#Main_Left-List").hide();
	
	Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(1).text();

	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	
	MqttJsonGroupSecondPage.prototype._LoadBroker_(number);
	MqttJsonGroupSecondPage.prototype._SetInitialValue_(number);
}

MqttJsonGroupFirstPage.prototype._AddNewRow_ = function(that)
{
	MqttJsonGroupFirstPage.prototype._CheckGroupName_();
	var Id = "#GroupTable";
	var ShowErrorMessage = $(Id).find(".Row").eq(0).find(".Message").is(":visible");
	if(ShowErrorMessage == true)	{return 0;}
	MqttJsonGroupFirstPage.prototype._InitialMqttJsonGroupObject_(that);
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
	MqttJsonGroupFirstPage.prototype._AutomaticGroupName_();
}

MqttJsonGroupFirstPage.prototype._DeleteRow_ = function(that)
{
	var Id = "#GroupTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		var number = element.eq(i).closest(".DynamicRow").find(".Column").eq(0).text();
		MqttJsonGroupFirstPage.prototype._RemoveGroup_(number);
	}
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
}

MqttJsonGroupFirstPage.prototype._IsNameRepeat_ = function(Name)
{
	var Return=false;
	var Row = $("#Main_Center-Content").find(".Body").eq(1).find(".Form").eq(0).find(".Row");
	var CurrentlyNumber = Row.eq(0).find(".Text").val();
	var number = Object.keys(Global_MqttJsonGroup);
	for(var i=0; i<number.length; i++)
	{
		if(Name == Global_MqttJsonGroup[number[i]]["Name"])
		{
			Return=true;
			break;
		}
	}
	return Return;
}




















//第2頁
MqttJsonGroupSecondPage.prototype._CheckGroupName_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var Name = $(that).closest(".Row").find(".Text").val();
	var Class = new Type();
	if(Class.EnglishDigitalAndBottomline(Name) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
	if(MqttJsonGroupSecondPage.prototype._IsNameRepeat_(Name) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
}

MqttJsonGroupSecondPage.prototype._IsNameRepeat_ = function(Name)
{
	var Return=false;
	var Row = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var CurrentlyNumber = Row.eq(0).find(".Text").val();
	var number = Object.keys(Global_MqttJsonGroup);
	for(var i=0; i<number.length; i++)
	{
		if(number[i] == CurrentlyNumber)
		{
			continue;
		}	
		if(Name == Global_MqttJsonGroup[number[i]]["Name"])
		{
			Return=true;
			break;
		}
	}
	return Return;
}

MqttJsonGroupSecondPage.prototype._GetMqttConnection_ = function()
{
	var Return=new Array();  var Bool;
	var BrokerTable = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row").eq(7).find(".BrokerTable");
	var BrokerTr = BrokerTable.find(".BrokerTr");
	for(var i=0; i<BrokerTr.length; i++)
	{
		Bool = BrokerTr.eq(i).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked");
		if(Bool == true)
		{
			Return.push(BrokerTr.eq(i).find(".BrokerTd").eq(1).text());
		}
	}
	return Return;
}

MqttJsonGroupSecondPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

MqttJsonGroupSecondPage.prototype._CheckGlobalVariableValueExist_ = function(number)
{
	if(typeof(Global_MqttJsonGroup[number]["Timestamp"]) == "undefined")
	{
		Global_MqttJsonGroup[number]["Timestamp"] = false;
	}
}

MqttJsonGroupSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var MqttClientSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	MqttClientSettings.eq(0).find(".Text").val(number);
	MqttClientSettings.eq(1).find(".Text").val(Global_MqttJsonGroup[number]["Name"]);
	MqttClientSettings.eq(2).find(".Text").val(Global_MqttJsonGroup[number]["ScanRate"]);
	MqttClientSettings.eq(3).find(".Text").val(Global_MqttJsonGroup[number]["DeadBand"]);
	MqttClientSettings.eq(4).find(".Text").val(Global_MqttJsonGroup[number]["WillTopic"]);
	MqttClientSettings.eq(5).find(".Text").val(Global_MqttJsonGroup[number]["Will"]);
	MqttClientSettings.eq(6).find(".Checkbox").prop("checked", Global_MqttJsonGroup[number]["Timestamp"]);
	var PublishAndSubscribe = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1).find(".Row");
	PublishAndSubscribe.eq(0).find(".Text").val(Global_MqttJsonGroup[number]["PublishTopic"]);
	PublishAndSubscribe.eq(1).find(".Select").val(Global_MqttJsonGroup[number]["PublishQos"]);
	PublishAndSubscribe.eq(2).find(".Text").val(Global_MqttJsonGroup[number]["SubscribeTopic"]);
	PublishAndSubscribe.eq(3).find(".Select").val(Global_MqttJsonGroup[number]["SubscribeQos"]);
	PublishAndSubscribe.eq(4).find(".Select").val(Global_MqttJsonGroup[number]["Retain"]);
}

MqttJsonGroupSecondPage.prototype._SetInitialValue_ = function(number)
{
	MqttJsonGroupSecondPage.prototype._CheckGlobalVariableValueExist_(number);
	MqttJsonGroupSecondPage.prototype._SetFormInitialValue_(number);
}

MqttJsonGroupSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Form").find(".Message").hide();
	var Element = $("#Main_Center-Content").find(".Body").eq(2).find(".Message");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).is(":visible") == true){
			$(that).closest(".Row").find(".Message").show();
			return 0;
		}
	}
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	var OldGroupName = Global_MqttJsonGroup[number]["Name"];
	var NewGroupName = ContentSettings.eq(1).find(".Text").val();
	MqttJsonGroupSecondPage.prototype._ModifyGlobalVariable_(OldGroupName, NewGroupName);
	MqttJsonGroupSecondPage.prototype._ModifyMqttJsonGroupObject_(number);
	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	MqttJsonGroupFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-MqttJsonGroup").text(), 1, "main_PathMqttJsonGroup_click(this)");
	
}

MqttJsonGroupSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-MqttJsonGroup").text(), 1, "main_PathMqttJsonGroup_click(this)");
	
}

MqttJsonGroupSecondPage.prototype._ModifyMqttJsonGroupObject_ = function(number)
{
	var MqttClientSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	MqttClientSettings.eq(0).find(".Text").val(number);
	Global_MqttJsonGroup[number]["Name"]           = MqttClientSettings.eq(1).find(".Text").val();
	Global_MqttJsonGroup[number]["ScanRate"]       = parseInt(MqttClientSettings.eq(2).find(".Text").val());
	Global_MqttJsonGroup[number]["DeadBand"]       = parseFloat(MqttClientSettings.eq(3).find(".Text").val());
	Global_MqttJsonGroup[number]["WillTopic"]      = MqttClientSettings.eq(4).find(".Text").val();
	Global_MqttJsonGroup[number]["Will"]           = MqttClientSettings.eq(5).find(".Text").val();
	Global_MqttJsonGroup[number]["Timestamp"]      = MqttClientSettings.eq(6).find(".Checkbox").prop("checked");
	Global_MqttJsonGroup[number]["MqttConnection"] = MqttJsonGroupSecondPage.prototype._GetMqttConnection_();

	var PublishAndSubscribe = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1).find(".Row");
	Global_MqttJsonGroup[number]["PublishTopic"]   = PublishAndSubscribe.eq(0).find(".Text").val();
	Global_MqttJsonGroup[number]["PublishQos"]     = parseInt(PublishAndSubscribe.eq(1).find(".Select").val());
	Global_MqttJsonGroup[number]["SubscribeTopic"] = PublishAndSubscribe.eq(2).find(".Text").val();
	Global_MqttJsonGroup[number]["SubscribeQos"]   = parseInt(PublishAndSubscribe.eq(3).find(".Select").val());
	Global_MqttJsonGroup[number]["Retain"]         = parseInt(PublishAndSubscribe.eq(4).find(".Select").val());
}

MqttJsonGroupSecondPage.prototype._LoadBroker_ = function(number)
{
	var Body = $("#Main_Center-Content").find(".Body").eq(2);
	var Html = Body.find(".MqttConnectionDynamic").html();
	var Form = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0);
	var Row = Form.find(".Row").eq(7);
	var Table = Row.find(".BrokerTable");
	Table.empty();

	var RemoteNumber = Object.keys(Global_RemoteBroker);
	MqttJsonGroupSecondPage.prototype._AddBrokerHtml_(Table, RemoteNumber);
	MqttJsonGroupSecondPage.prototype._SetBrokerValue_(number, Table, RemoteNumber);
}

MqttJsonGroupSecondPage.prototype._AddBrokerHtml_ = function(Table, RemoteNumber)
{
	var Html = $("#Main_Center-Content").find(".Body").eq(2).find(".MqttConnectionDynamic").html();
	$(Table).append(Html);
	for(var i=0; i<RemoteNumber.length; i++)
	{
		$(Table).append(Html);
	}
/*	for(var i=0; i<AzureNumber.length; i++)
	{
		$(Table).append(Html);
	}*/
}

MqttJsonGroupSecondPage.prototype._SetBrokerValue_ = function(number, Table, RemoteNumber)
{
	var obj={Index:0};  var BrokerName;
	var Tr = Table.find(".BrokerTr");
	var BrokerName = Global_MqttJsonGroup[number]["MqttConnection"];
	MqttJsonGroupSecondPage.prototype._SetLocalBrokerName_(Tr, obj, BrokerName);
	MqttJsonGroupSecondPage.prototype._SetRemoteBrokerName_(Tr, obj, RemoteNumber, BrokerName);
//	MqttJsonGroupSecondPage.prototype._SetAzureBrokerName_(Tr, obj, AzureNumber, BrokerName);
	if(Tr.find(".BrokerTd").find(":checked").length == 0)
	{
		Tr.closest(".Row").find(".Message").show();
	}
}

MqttJsonGroupSecondPage.prototype._SetLocalBrokerName_ = function(Tr, obj, BrokerName)
{
	var array = new Array("Broker (Local)");
	var Name = MqttJsonGroupSecondPage.prototype._ArrayInteraction_(BrokerName, array);
	if(Name.length>0)
	{
		Tr.eq(obj.Index).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked",true);
	}
	Tr.eq(obj.Index).find(".BrokerTd").eq(1).text("Broker (Local)");
}

MqttJsonGroupSecondPage.prototype._SetRemoteBrokerName_ = function(Tr, obj, RemoteNumber, BrokerName)
{
	for(var i=0; i<RemoteNumber.length; i++)
	{
		obj.Index=obj.Index+1;
		var RemoteBroker = Global_RemoteBroker[RemoteNumber[i]]["Name"];
		var array = new Array(RemoteBroker+" (Remote)");
		Name = MqttJsonGroupSecondPage.prototype._ArrayInteraction_(BrokerName, array);
		if(Name.length>0)
		{
			Tr.eq(obj.Index).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked",true);
		}
		Tr.eq(obj.Index).find(".BrokerTd").eq(1).text(Global_RemoteBroker[RemoteNumber[i]]["Name"]+" (Remote)");
	}
}

/*MqttJsonGroupSecondPage.prototype._SetAzureBrokerName_ = function(Tr, obj, AzureNumber, BrokerName)
{
	for(var i=0; i<AzureNumber.length; i++)
	{
		obj.Index=obj.Index+1;
		var AzureBroker = Global_AzurePlatform[AzureNumber[i]]["Name"];
		var array = new Array(AzureBroker+" (Azure)");
		Name = MqttJsonGroupSecondPage.prototype._ArrayInteraction_(BrokerName, array);
		if(Name.length>0)
		{
			Tr.eq(obj.Index).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked",true);
		}
		Tr.eq(obj.Index).find(".BrokerTd").eq(1).text(Global_AzurePlatform[AzureNumber[i]]["Name"]+" (Azure)");
	}
}*/

MqttJsonGroupSecondPage.prototype._CheckScanRate_ = function(that)
{
	var ScanRate = $(that).closest(".RightColumn").find(".Text").val();
	var Class = new Type();
	ScanRate = parseInt(ScanRate);
	if(Class.CheckPositiveIntegers(ScanRate) == false)
	{
		$(that).closest(".RightColumn").find(".Text").val(1000);
		return 0;
	}
	if(ScanRate < 100)
	{
		$(that).closest(".RightColumn").find(".Text").val(1000);
		return 0;
	}
	$(that).closest(".RightColumn").find(".Text").val(ScanRate);
}

MqttJsonGroupSecondPage.prototype._CheckDeadBand_ = function(that)
{
	var DeadBand = $(that).closest(".RightColumn").find(".Text").val();
	var Class = new Type();
	DeadBand = parseFloat(DeadBand);
	if(Class.CheckFloat(DeadBand) == false)
	{
		$(that).closest(".RightColumn").find(".Text").val(0);
		return 0;
	}
	if(DeadBand < 0)
	{
		$(that).closest(".RightColumn").find(".Text").val(0);
		return 0;
	}
	DeadBand = parseFloat(DeadBand.toFixed(4));
	$(that).closest(".RightColumn").find(".Text").val(DeadBand);
}

MqttJsonGroupSecondPage.prototype._CheckMqttConnection_ = function(that)
{
	$(that).closest(".RightColumn").find(".Message").hide();
	var MqttConnection=false;
	var Table = $(that).closest(".BrokerTable");
	var Tr = Table.find(".BrokerTr");
	for(var i=0; i<Tr.length; i++)
	{
		var Bool = Tr.eq(i).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked");
		if(Bool == true)
		{
			MqttConnection = true;
			break;
		}
	}
	if(MqttConnection == false)
	{
		$(that).closest(".RightColumn").find(".Message").show();
	}
}

MqttJsonGroupSecondPage.prototype._CheckTopic_ = function(that)
{
	$(that).closest(".Form").find(".Message").hide();
	var Row = $(that).closest(".Form").find(".Row");
	var PublishTopic = Row.eq(0).find(".Text").val();
	var SubscribeTopic = Row.eq(2).find(".Text").val();
	if(PublishTopic=="" && SubscribeTopic=="")
	{
		Row.eq(0).find(".Message").show();
		Row.eq(2).find(".Message").show();
	}
}

MqttJsonGroupSecondPage.prototype._ModifyGlobalVariable_ = function(OldGroupName, NewGroupName)
{
	MqttJsonGroupSecondPage.prototype._ModifyRtuToMqttJsonGroupName_(OldGroupName, NewGroupName);
	MqttJsonGroupSecondPage.prototype._ModifyTcpToMqttJsonGroupName_(OldGroupName, NewGroupName);
	MqttJsonGroupSecondPage.prototype._ModifyAsciiToMqttJsonGroupName_(OldGroupName, NewGroupName);
}

MqttJsonGroupSecondPage.prototype._ModifyRtuToMqttJsonGroupName_ = function(OldGroupName, NewGroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_RtuToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(OldGroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_RtuToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = NewGroupName;
			}
		}
	}
}

MqttJsonGroupSecondPage.prototype._ModifyTcpToMqttJsonGroupName_ = function(OldGroupName, NewGroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_TcpToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(OldGroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_TcpToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = NewGroupName;
			}
		}
	}
}

MqttJsonGroupSecondPage.prototype._ModifyAsciiToMqttJsonGroupName_ = function(OldGroupName, NewGroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_AsciiToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(OldGroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_AsciiToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = NewGroupName;
			}
		}
	}
}