//更新頁
MqttToOpcuaUpdatePage.prototype._SaveGlobalVariable_ = function(Row)
{
	var Class = new StepFlow();
	Class.LockAllUi();
	var ssocket = io.connect(), Index=0, Length=Row.length;
	Row.eq(Index).find(".Button").click();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
		if(Row.eq(Index).find(".Message").is(":visible") == true && 
		   Row.eq(Index).find(".Message").css("color") == "rgb(34, 119, 0)")//成功
		{
			Index++;
			Row.eq(Index).find(".Button").click();
			ssocket.emit("BackgroundExecution");
			if(Index==Length)
			{
				ssocket.emit("SocketClose");
				MqttToOpcuaUpdatePage.prototype._ShowFirstPage_();
				Class.UnLockAllUi();
			}
		}
		else if(Index<Length)
		{
			ssocket.emit("BackgroundExecution");
		}
	});
}


MqttToOpcuaUpdatePage.prototype._IsSaveGlobalVariable_ = async function() 
{
	const Class = new Judgment();
	const [Bool_1, Bool_2] = await Promise.all([
		Class.IsSaveMqttModuleGlobalVariable(),
		Class.IsSaveRemoteBrokerGlobalVariable()
	]);
	return Bool_1 && Bool_2;
}
	

MqttToOpcuaUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	MqttToOpcuaFirstPage.prototype._Initialization_();
}

MqttToOpcuaUpdatePage.prototype._Initialization_ = async function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(await MqttToOpcuaUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		MqttToOpcuaUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	MqttToOpcuaUpdatePage.prototype._SaveGlobalVariable_(Row);
}




















//第1頁
MqttToOpcuaFirstPage.prototype._ChangeCheckbox_ = function(that)
{
	var Bool = $(that).closest(".DynamicRow").find(".Column").eq(3).find(":checkbox").prop("checked");
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	if(typeof(Global_MqttToOpcuaVariable[number])!="object"){
		return;
	}
	var SystemVariable = Object.keys(Global_MqttVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		Global_MqttToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"] = Bool;
	}
}

MqttToOpcuaFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var ModuleTableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+ ModuleTableId).find(".DynamicRow");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").prop("checked",Bool);
			var that = Element.eq(i).find(":checkbox");
			MqttToOpcuaFirstPage.prototype._ChangeCheckbox_(that);
		}
	}
}

MqttToOpcuaFirstPage.prototype._IsAllTransformOpcUa_ = function(number)
{
	var Return=false;
	if(typeof(Global_MqttToOpcuaVariable[number]) != "object")
	{
		return Return;
	}
	var SystemVariable=Object.keys(Global_MqttToOpcuaVariable[number]);
	if(SystemVariable.length==0)
	{
		return Return;
	}
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(Global_MqttToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"]==false)
		{
			return Return;
		}
	}
	Return = true;
	return Return;
}

MqttToOpcuaFirstPage.prototype._GetAllModuleData_ = function()
{
	var Return = new Object();
	var DeviceName = Object.keys(Global_MqttModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		var nmuber = Object.keys(Global_MqttModule[DeviceName[i]]);
		for(var j=0; j<nmuber.length; j++)
		{
			Return[nmuber[j]] = new Object();
			Return[nmuber[j]] = jQuery.parseJSON(JSON.stringify(Global_MqttModule[DeviceName[i]][nmuber[j]]));
		}
	}
	return Return;
}

MqttToOpcuaFirstPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

MqttToOpcuaFirstPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return = new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

MqttToOpcuaFirstPage.prototype._GetAllDeviceName_ = function()
{
	var Return=Object.keys(Global_MqttModule);
	return Return;
}

MqttToOpcuaFirstPage.prototype._GetAllNumber_ = function()
{
	var AllDeviceName = MqttToOpcuaFirstPage.prototype._GetAllDeviceName_();
	var ObjectKey = new Array();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_MqttModule[AllDeviceName[i]]) == "object")
		{
			ObjectKey = ObjectKey.concat(Object.keys(Global_MqttModule[AllDeviceName[i]]));
		}
	}
	ObjectKey = ObjectKey.sort(function (a, b) {return a - b});
	return ObjectKey;
}

MqttToOpcuaFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	var AllModuleData = MqttToOpcuaFirstPage.prototype._GetAllModuleData_();
	$("#ModuleTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#ModuleToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(1).text(AllModuleData[ObjectKey[i]]["ModuleName"]);
		var Bool = MqttToOpcuaFirstPage.prototype._IsAllTransformOpcUa_(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(3).find(":checkbox").prop("checked",Bool);
		index++;
	}
}

MqttToOpcuaFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#ModuleToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

MqttToOpcuaFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 20;//RTU 20 TCP 40 ASCII 20
	var ObjectKey = MqttToOpcuaFirstPage.prototype._GetAllNumber_();
	MqttToOpcuaFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	MqttToOpcuaFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

MqttToOpcuaFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	MqttToOpcuaFirstPage.prototype._RedisplayUi_();
}

MqttToOpcuaFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	MqttToOpcuaFirstPage.prototype._RedisplayUi_();
}

MqttToOpcuaFirstPage.prototype._Initialization_ = function()
{
	MqttToOpcuaFirstPage.prototype._RedisplayUi_();
}

MqttToOpcuaFirstPage.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
}

MqttToOpcuaFirstPage.prototype._SaveFinished_ = function(that, ssocket)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").eq(1).show();
	ssocket.emit("SaveFinished");
	ssocket.on("SaveFinished", function (Return) {
		if(Return == true)
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(2).show();
		}
		ssocket.emit("SocketClose");
	});
}
 
MqttToOpcuaFirstPage.prototype._SaveStart_ = function(that, ssocket)
{
	that.disabled = true;
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
    if (Return == true) {
      var Callback0 = function () {
		that.disabled = false;
        MqttToOpcuaFirstPage.prototype._SaveFinished_(that, ssocket);
      };
      var JsonString = JSON.stringify(Global_MqttToOpcuaVariable);
      $(that).closest(".Row").find(".Message").hide();
      $(that).closest(".Row").find(".Loading").show();
      MqttToOpcuaFirstPage.prototype._TransmissionJson_(
        ssocket,
        "SaveMqttToOpcuaVariable",
        JsonString,
        Callback0
      );
    } else {
      that.disabled = false;
    }
  });
} 

MqttToOpcuaFirstPage.prototype._EditButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
	var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	$("#Main_Center-Content").find(".Body").eq(2).show();
	var Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text();
	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	
	MqttToOpcuaSecondPage.prototype._SetInitialValue_(number);
}

MqttToOpcuaFirstPage.prototype._SaveButton_ = function(that)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").hide();
	var ssocket = io.connect();
	MqttToOpcuaFirstPage.prototype._SaveStart_(that, ssocket);
}




















//第2頁
MqttToOpcuaSecondPage.prototype._VariableTableAddNewRow_ = function(number)
{
	if(typeof(Global_MqttToOpcuaVariable[number]) != "object")	{return 0;}
	var html="", TempHtml = $("#Main_Center-Content").find(".Body").eq(2).find(".Dynamic").html();
	var SystemVariable = Object.keys(Global_MqttToOpcuaVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		html = html + TempHtml;
	}
	$("#VariableTable").append(html);
}

MqttToOpcuaSecondPage.prototype._SetVariableTableNewRowValue_ = function(number)
{
	if(typeof(Global_MqttToOpcuaVariable[number]) != "object")	{return 0;}
	var Variable = Global_MqttVariable[number];
	var Class=new Algorithm();
	var SystemVariable = Object.keys(Global_MqttToOpcuaVariable[number]).sort(Class.StringNumberMixedSort());
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<SystemVariable.length; i++)
	{
		Row.eq(i).find(".Column").eq(0).text(SystemVariable[i]);
		Row.eq(i).find(".Column").eq(1).text(Variable[SystemVariable[i]]["VariableName"]);
		var ReadWriteType = MqttToOpcuaSecondPage.prototype._GetReadWriteType_(SystemVariable[i].split("-")[0]);
		Row.eq(i).find(".Column").eq(2).find(".Select").val(ReadWriteType);
		Row.eq(i).find(".Column").eq(3).text(SystemVariable[i].split("-")[1]);
		var Bool = Global_MqttToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"];
		Row.eq(i).find(".Column").eq(4).find(".Checkbox").prop("checked",Bool);
	}
}

MqttToOpcuaSecondPage.prototype._GetModuleName_ = function(number)
{
	var Return = "";
	var DeviceName = Object.keys(Global_MqttModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		if(typeof(Global_MqttModule[DeviceName[i]][number]) == "object")
		{
			Return = Global_MqttModule[DeviceName[i]][number]["ModuleName"];
			break;
		}
	}
	return Return;
}

MqttToOpcuaSecondPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

MqttToOpcuaSecondPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

MqttToOpcuaSecondPage.prototype._ClearTable_ = function(number)
{
	$("#VariableTable").find(".Row").eq(0).find(".Checkbox").prop("checked",false);
	$("#VariableTable").find(".DynamicRow").remove();
}

MqttToOpcuaSecondPage.prototype._SetVariableTableInitialValue_ = function(number)
{
	MqttToOpcuaSecondPage.prototype._VariableTableAddNewRow_(number);
	MqttToOpcuaSecondPage.prototype._SetVariableTableNewRowValue_(number);
}

MqttToOpcuaSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var ModuleName=MqttToOpcuaSecondPage.prototype._GetModuleName_(number);
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	ContentSettings.eq(1).find(".Text").val(ModuleName);
}

MqttToOpcuaSecondPage.prototype._SetInitialValue_ = function(number)
{
	MqttToOpcuaSecondPage.prototype._ClearTable_(number);
	MqttToOpcuaSecondPage.prototype._SetFormInitialValue_(number);
	MqttToOpcuaSecondPage.prototype._SetVariableTableInitialValue_(number);
}

MqttToOpcuaSecondPage.prototype._ModifyMqttToOpcuaVariableObject_ = function(number)
{
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<Row.length; i++)
	{
		var SystemVariable = Row.eq(i).find(".Column").eq(0).text();
		var Bool = Row.eq(i).find(":checkbox").prop("checked");
		Global_MqttToOpcuaVariable[number][SystemVariable]["TransformOpcUa"] = Bool;
	}
}

MqttToOpcuaSecondPage.prototype._ConfirmButton_ = function()
{
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	MqttToOpcuaSecondPage.prototype._ModifyMqttToOpcuaVariableObject_(number);
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	MqttToOpcuaFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-MqttToOpcua").text(), 1, "main_PathMqttToOpcua_click(this)");
	
}

MqttToOpcuaSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-MqttToOpcua").text(), 1, "main_PathMqttToOpcua_click(this)");
	
}

MqttToOpcuaSecondPage.prototype._GetReadWriteType_ = function(string)
{
	var Return;
	if(string == "DO")			{Return = "ReadWrite";}
	else if(string == "DI")		{Return = "Read";}
	else if(string == "AO")		{Return = "ReadWrite";}
	else if(string == "AI")		{Return = "Read";}
	return Return;
}