
// IPv6
NetworkSetting.prototype._GetIPv6Setting_ = function(Result)
{
	var Return={"Input":null};
	var Class = new Transmission();
	var Lan1Ipv6Row = $("#IPv6_Lan1NetworkSetting").find(".Row");
	var Lan2Ipv6Row = $("#IPv6_Lan2NetworkSetting").find(".Row");
	Class.TransmissionArray("GetIPv6IP", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			Result["Input"] = true;
		}
		if(Array.isArray(Return["Input"]) == true && Return["Input"].length != 0)
		{
			if(Return["Input"][2]=="")
				Return["Input"][2]=="::"
			if(Return["Input"][5]=="")
				Return["Input"][5]=="::"
				
			Global_NetworkSetting["Lan1"]["IPv6"]["IP"]=Return["Input"][0];
			Global_NetworkSetting["Lan1"]["IPv6"]["Mask"]=Return["Input"][1];
			Global_NetworkSetting["Lan1"]["IPv6"]["Gateway"]=Return["Input"][2];
			Global_NetworkSetting["Lan2"]["IPv6"]["IP"]=Return["Input"][3];
			Global_NetworkSetting["Lan2"]["IPv6"]["Mask"]=Return["Input"][4];
			Global_NetworkSetting["Lan2"]["IPv6"]["Gateway"]=Return["Input"][5];
			
			Lan1Ipv6Row.eq(2).find(".Text").eq(0).val(Return["Input"][0]);
			Lan1Ipv6Row.eq(3).find(".Text").eq(0).val(Return["Input"][1]);
			Lan1Ipv6Row.eq(4).find(".Text").eq(0).val(Return["Input"][2]);

			Lan2Ipv6Row.eq(2).find(".Text").eq(0).val(Return["Input"][3]);
			Lan2Ipv6Row.eq(3).find(".Text").eq(0).val(Return["Input"][4]);
			Lan2Ipv6Row.eq(4).find(".Text").eq(0).val(Return["Input"][5]);

		}
	},500);
};

NetworkSetting.prototype._OpenIPv6Button_ = function(Bool)
{
	var IPv6Status = $(".IPv6SetClass").find(".Row").eq(0).find(":checkbox").prop("checked");
	if(IPv6Status == true)
	{
		//alert("打開按鈕");
		if(Global_NetworkSetting["Lan1"]["Status"])
			$("#IPv6_Lan1NetworkSetting").show();
	    else
			$("#IPv6_Lan1NetworkSetting").hide();
		
		if(Global_NetworkSetting["Lan2"]["Status"])
			$("#IPv6_Lan2NetworkSetting").show();
	    else
			$("#IPv6_Lan2NetworkSetting").hide();
		
		$("#LanIPv6Save").show(); //顯示Save欄
	
	} 
	else
	{
		//alert("關閉按鈕");
		$("#IPv6_Lan1NetworkSetting").hide();
		$("#IPv6_Lan2NetworkSetting").hide();
		// $(".Form").eq(6).hide();
		$("#LanIPv6Save").hide(); //隱藏Save欄
	}
};

NetworkSetting.prototype._Lan1IPv6ChangeRadio_ = function(Bool)
{
	$("#IPv6_Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).attr('disabled', Bool);
	$("#IPv6_Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).attr('disabled', Bool);
	$("#IPv6_Lan1NetworkSetting").find(".Row").eq(4).find(".Text").eq(0).attr('disabled', Bool);
};

NetworkSetting.prototype._Lan2IPv6ChangeRadio_ = function(Bool)
{
	$("#IPv6_Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).attr('disabled', Bool);
	$("#IPv6_Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).attr('disabled', Bool);	
	$("#IPv6_Lan2NetworkSetting").find(".Row").eq(4).find(".Text").eq(0).attr('disabled', Bool);
};

NetworkSetting.prototype._SetIPv6Lan1NetworkSetting_ = function(that)
{
	var Lan1_Ipv6_static = $("#IPv6_Lan1NetworkSetting").find("input[type=radio]")[0].checked;
	//var Lan1_IPv6_dhcp = $("#IPv6_Lan1NetworkSetting").find("input[type=radio]")[1].checked;

	if(Lan1_Ipv6_static == true)
	{
		NetworkSetting.prototype._SetLan1IPv6StaticIP_(that);
	}

};
NetworkSetting.prototype._SetLan1IPv6StaticIP_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._Lan1IPv6AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	NetworkSetting.prototype._TransmissionLan1IPv6StaticIpAllData_(that);
};
NetworkSetting.prototype._SetLan1IPv6dhcpIP_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	var ssocket = io.connect();
	NetworkSetting.prototype._TransmissionLan1IPv6Dhcp_(that, ssocket);
};
NetworkSetting.prototype._TransmissionLan1IPv6Dhcp_ = function(that, ssocket)
{
	SetLan2Dhcp()
};
NetworkSetting.prototype._Lan1IPv6AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#IPv6_Lan1NetworkSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};
NetworkSetting.prototype._TransmissionLan1IPv6StaticIpAllData_ = function(that)
{
	var array = NetworkSetting.prototype._CollectLan1IPv6AllData_();
	var Return={"Input":null};
	var Class = new Transmission();
	alert("Send socket.emit IPv6 Static");
	Class.TransmissionArray("SetIPv6Setting", array, Return);

	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			 
		}
		if(Return["Input"] == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();		
		}
		else if(Return["Input"] == false)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(2).show();
		}
	}, 500);
	NetworkSetting.prototype._TransferIpAddress_(that, array[0],"Lan1");
};

NetworkSetting.prototype._CollectLan1IPv6AllData_ = function()
{
	var IP = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val();
	var Mask = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val();
	var Gateway = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val();
	var Return = new Array(IP, Mask, Gateway);
	return Return;
};

// IPv6 Lan2
NetworkSetting.prototype._SetIPv6NetworkSetting_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._Lan1IPv6AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	if(NetworkSetting.prototype._Lan2IPv6AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	var array = NetworkSetting.prototype._CollectIPv6AllData_();
	//var array = NetworkSetting.prototype._CollectLan1AllData_();
	var Return={"Input":null};
	var Class = new Transmission();
	//alert("Send socket.emit IPv6 Static123456");
	Class.TransmissionArray("SetIPv6Setting", array, Return);
	//Class.TransmissionArray("Lan1_SetIpv4StaticIp", array, Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			 
		}
		if(Return["Input"] == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
		else if(Return["Input"] == false)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(2).show();
		}
	}, 500);
};
NetworkSetting.prototype._SetLan2IPv6StaticIP_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._Lan2IPv6AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	NetworkSetting.prototype._TransmissionLan2IPv6StaticIpAllData_(that);
};
NetworkSetting.prototype._Lan2IPv6AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#IPv6_Lan2NetworkSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};
NetworkSetting.prototype._TransmissionLan2IPv6StaticIpAllData_ = function(that)
{
	var array = NetworkSetting.prototype._CollectLan2IPv6AllData_();
	var Class = new Transmission();
	NetworkSetting.prototype._TransferIpAddress_(that, sarray[0],"Lan2");
	//alert("Send Lan2 socket.emit IPv6 Static");
	$(that).closest('.Form').find(".Loading").hide();
	$(that).closest('.Form').find(".Message").eq(0).show();
	
};
NetworkSetting.prototype._CollectIPv6AllData_ = function()
{
	var Lan1_Ipv6_static = $("#IPv6_Lan1NetworkSetting").find("input[type=radio]")[0].checked;
	var Lan1Mode;
	var Lan2Model;
	if(Lan1_Ipv6_static == true)
	{
		Lan1Model = "static";
	}
	else
	{
		Lan1Model = "dhcp";
	}
			

	var Lan2_Ipv6_static = $("#IPv6_Lan2NetworkSetting").find("input[type=radio]")[0].checked;
	//var Lan2_IPv6_dhcp = $("#IPv6_Lan2NetworkSetting").find("input[type=radio]")[1].checked;
	if(Lan2_Ipv6_static == true)
	{
		Lan2Model = "static";
	}
	else
	{
		Lan2Model = "dhcp";
	}
	
	var IP_1 = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val();
	var Mask_1 = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val();
	var Gateway_1 = $("#IPv6_Lan1NetworkSetting").find(".Row").eq(4).find(".Text").eq(0).val();
	var IP_2 = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val();
	var Mask_2 = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val();
	var Gateway_2 = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(4).find(".Text").eq(0).val();
	var Return = new Array(Lan1Model, Lan2Model, IP_1, Mask_1, Gateway_1, IP_2, Mask_2, Gateway_2);
	return Return;
};


NetworkSetting.prototype._CollectLan2IPv6AllData_ = function()
{
	var IP = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val();
	var Mask = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val();
	var Gateway = $("#IPv6_Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val();
	var Return = new Array(IP, Mask, Gateway);
	return Return;
};
// IPv6 DHCP Setting
NetworkSetting.prototype._SetLan2IPv6dhcpIP_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	var ssocket = io.connect();
	NetworkSetting.prototype._TransmissionLan2IPv6Dhcp_(that, ssocket);
};

NetworkSetting.prototype._TransmissionLan2IPv6Dhcp_ = function(that, ssocket)
{
	/* alert("Send Lan2 socket.emit dhcp setting");
	$(that).closest('.Form').find(".Loading").hide();
	$(that).closest('.Form').find(".Message").eq(0).show(); */

	/*ssocket.emit('Lan1_SetDhcp');
	ssocket.on('Lan1_SetDhcp', function (Return) {
		if(Return == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(1).show();
		}
		ssocket.emit("SocketClose");
	});*/
};

NetworkSetting.prototype._Lan1ChangeRadio_ = function(Bool)//設定dhcp時不能設定 
{
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).attr('disabled', Bool);
	
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).attr('disabled', Bool);
	
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).attr('disabled', Bool);
};

NetworkSetting.prototype._Lan2ChangeRadio_ = function(Bool)
{
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).attr('disabled', Bool);
	
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).attr('disabled', Bool);
	
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).attr('disabled', Bool);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).attr('disabled', Bool);
};

NetworkSetting.prototype._GetDdns_ = function(Result)
{
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("GetDdns", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Array.isArray(Return["Input"]) == true && Return["Input"].length != 0)
		{
			clearInterval(SetInterval);
			  
			Result["Input"] = true;
			$("#DdnsSetting").find(".Row").eq(0).find(".Select").eq(0).val(Return["Input"][0]);
			$("#DdnsSetting").find(".Row").eq(1).find(".Text").eq(0).val(Return["Input"][1]);
			$("#DdnsSetting").find(".Row").eq(2).find(".Text").eq(0).val(Return["Input"][2]);
			$("#DdnsSetting").find(".Row").eq(3).find(".Text").eq(0).val(Return["Input"][3]);
		}
	},500);
};

NetworkSetting.prototype._SetDdns_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._DdnsAllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(2).show();
		return 0;
	}
	//收集資料
	var array = NetworkSetting.prototype._CollectDdnsAllData_();
	//傳輸資料
	var ssocket = io.connect();
	NetworkSetting.prototype._TransmissionDdnsData_(that, array, ssocket);
};

NetworkSetting.prototype._TransmissionDdnsData_ = function(that, array, ssocket)
{
	ssocket.emit('SetDdns', array);
	ssocket.on('SetDdns', function (Return) {
		if(Return == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(1).show();
		}
		ssocket.emit("SocketClose");
	});
};

NetworkSetting.prototype._DdnsAllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#DdnsSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#DdnsSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};

NetworkSetting.prototype._CollectDdnsAllData_ = function()
{
	var ServiceProvider = $("#DdnsSetting").find(".Row").eq(0).find(".Select").eq(0).val();
	var Username        = $("#DdnsSetting").find(".Row").eq(1).find(".Text").eq(0).val();
	var Password        = $("#DdnsSetting").find(".Row").eq(2).find(".Text").eq(0).val();
	var DomainName      = $("#DdnsSetting").find(".Row").eq(3).find(".Text").eq(0).val();
	var Return = new Array(ServiceProvider, Username, Password, DomainName);
	return Return;
};

NetworkSetting.prototype._GetHostname_ = function(Result)
{
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("GetHostname", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			  
			Result["Input"] = true;
			var Hostname = Return["Input"][0];
			$("#HostnameSetting").find(".Row").eq(0).find(".Text").eq(0).val(Hostname);
		}
	},500);
};

NetworkSetting.prototype._SetHostname_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._HostnameIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(2).show();
		return 0;
	}
	//收集資料
	var Hostname = $("#HostnameSetting").find(".Row").eq(0).find(".Text").eq(0).val();
	var array = new Array(Hostname);
	//傳輸資料
	var ssocket = io.connect();
	NetworkSetting.prototype._TransmissionHostnameData_(that, array, ssocket);
};

NetworkSetting.prototype._HostnameIsCorrect_ = function()
{
	var Return = true;
	var length = $("#HostnameSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#HostnameSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};

NetworkSetting.prototype._TransmissionHostnameData_ = function(that, array, ssocket)
{
	ssocket.emit('SetHostname', array);
	ssocket.on('SetHostname', function (Return) {
		if(Return == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(1).show();
		}
		ssocket.emit("SocketClose");
	});
};

NetworkSetting.prototype._ShowUi_ = function () 
{
	$("#Main_Center-Content").find(".Body").hide();  //隱藏所有設定;
	$("#Main_Center-Content").find(".Body").eq(0).show();
	var Result_1 = { "Input": null }; 
	var Result_2 = { "Input": null }; 
	//var IPv6_Result = { "Input": null }; 
	var Result_3 = { "Input": null }; 
	var Result_4 = { "Input": null }; 
	var Result_5 = { "Input": null };
	var Class = new Transmission();
	Class.TransmissionArray("DetectionModel", new Array(), Result_5);
	NetworkSetting.prototype._GetIPv4Setting_(Result_1);
	NetworkSetting.prototype._GetIPv6Setting_(Result_2);
	NetworkSetting.prototype._GetHostname_(Result_3);
	NetworkSetting.prototype._GetDdns_(Result_4);
	NetworkSetting.prototype._GetOpenVPNClientStatus_(Result_5);
	var SetInterval_2 = setInterval(function () {
		if (Result_1["Input"] == true && Result_2["Input"] == true && Result_3["Input"] == true && Result_4["Input"] == true && Result_5["Input"] != null) {
			NetworkSetting.prototype._ChangeUi_(Result_5["Input"]);
			var Class = new Wireless();
			Class.IsExistWirelessDevice();
			clearInterval(SetInterval_2);
		}
	}, 500);
};

NetworkSetting.prototype._ChangeUi_ = function(ProductName)
{
	var Lan1ConnectionMode=Global_NetworkSetting["Lan1"]["ConnectionMode"];
	var Lan2ConnectionMode=Global_NetworkSetting["Lan2"]["ConnectionMode"];
	
	if(!Global_NetworkSetting["Lan1"]["Status"])
	{
		$("#Lan1SettingTitle").hide();
		$("#Lan1NetworkSetting").hide(); //LAN1 IPV4設定欄 隱藏
		$("#Lan1IPv4Save").hide(); //LAN1 Save 設定欄 隱藏
		
		$("#IPv6_Lan1NetworkSetting").hide();
	}
	else
	{
		$("#Lan1SettingTitle").show();
		$("#Lan1NetworkSetting").show(); //LAN1 IPV4設定欄 
		switch(Lan1ConnectionMode)
		{
			case 'static':
				$("#Lan1_SetIPv4").attr('checked', true);
				$("#Lan1_DHCP").attr('checked', false);
				break;
			case 'dhcp':
				$("#Lan1_SetIPv4").attr('checked', false);
				$("#Lan1_DHCP").attr('checked', true);
				NetworkSetting.prototype._Lan1ChangeRadio_(true);
				break;
		}
		
		$("#Lan1IPv4Save").show(); //LAN1 Save 設定欄 
		$("#IPv6_Lan1NetworkSetting").show();
		
	}
	
	if(!Global_NetworkSetting["Lan2"]["Status"])
	{
		$("#Lan2SettingTitle").hide();
		$("#Lan2NetworkSetting").hide();
		$("#Lan2IPv4Save").hide(); //LAN2 Save 設定欄 隱藏
		$("#IPv6_Lan2NetworkSetting").hide();
	}
	else
	{
		$("#Lan2SettingTitle").show();
		$("#Lan2NetworkSetting").show();
		switch(Lan2ConnectionMode)
		{
			case 'static':
				$("#Lan2_SetIPv4").attr('checked', true);
				$("#Lan2_DHCP").attr('checked', false);
				break;
			case 'dhcp':
				$("#Lan2_SetIPv4").attr('checked', false);
				$("#Lan2_DHCP").attr('checked', true);
				NetworkSetting.prototype._Lan2ChangeRadio_(true);
				break;
		}
		
		$("#Lan2IPv4Save").show(); //LAN1 Save 設定欄 隱藏
		$("#IPv6_Lan2NetworkSetting").show();
	}
	
	if(ProductName == "UA-2241")
	{
		
	} 
};

NetworkSetting.prototype._CheckIp_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var IP = Text.eq(0).val() + "." + Text.eq(1).val() + "." + Text.eq(2).val() + "." + Text.eq(3).val();
	var Class = new Type();
	if(Class.CheckIp(IP) == true)	{$(that).closest(".Row").find(".Message").hide();}
	else							{$(that).closest(".Row").find(".Message").show();}
};

NetworkSetting.prototype._CheckMask_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var Mask = Text.eq(0).val() + "." + Text.eq(1).val() + "." + Text.eq(2).val() + "." + Text.eq(3).val();
	var Class = new Type();
	if(Class.CheckIp(Mask) == true)	{$(that).closest(".Row").find(".Message").hide();}
	else							{$(that).closest(".Row").find(".Message").show();}
};

NetworkSetting.prototype._CheckGateway_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var Gateway = Text.eq(0).val() + "." + Text.eq(1).val() + "." + Text.eq(2).val() + "." + Text.eq(3).val();
	var Class = new Type();
	if(Class.CheckIp(Gateway) == true)	{$(that).closest(".Row").find(".Message").hide();}
	else								{$(that).closest(".Row").find(".Message").show();}
};

NetworkSetting.prototype._CheckHostname_ = function(that)
{
	var Hostname=$(that).val();
	var Class=new Type();
	$(that).closest(".Row").find(".Message").hide();
	
	if(Class.CheckChineseLanguage(Hostname) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
	else if($(that).val() == "")
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
};

// Check IPv6 IP, Netmask, Gateway
NetworkSetting.prototype._CheckIp_v6_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var IP = Text.eq(0).val();
	var Class = new Type();
	if(Class.CheckIp_v6(IP) == true)	{$(that).closest(".Row").find(".Message").hide();}
	else								{$(that).closest(".Row").find(".Message").show();}
};

NetworkSetting.prototype._CheckMask_v6_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var Mask = Text.eq(0).val();
	if(Mask<=128 && Mask >0)	
	{
		$(that).closest(".Row").find(".Message").hide();
	}
	else
	{
		$(that).closest(".Row").find(".Message").show();
	}
};

NetworkSetting.prototype._CheckGateway_v6_ = function(that)
{
	var Text = $(that).closest(".Row").find(".Text");
	var Gateway = Text.eq(0).val();
	var Class = new Type();
	if(Class.CheckIp_v6(Gateway) == true)	{$(that).closest(".Row").find(".Message").hide();} //隱藏訊息
	else									{$(that).closest(".Row").find(".Message").show();}//顯示訊息
};

NetworkSetting.prototype._GetLan1Ipv4Ip_ = function(Result)
{
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("Lan1_GetIpv4Ip", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			  
			Result["Input"] = true;
		}
		if(Array.isArray(Return["Input"]) == true && Return["Input"].length != 0)
		{	
			Global_NetworkSetting["Lan1"]["IPv4"]["IP"]=Return["Input"][0];
			Global_NetworkSetting["Lan1"]["IPv4"]["Mask"]=Return["Input"][1];
			Global_NetworkSetting["Lan1"]["IPv4"]["Gateway"]=Return["Input"][2];
			Global_NetworkSetting["Lan1"]["ConnectionMode"]=Return["Input"][3];
			NetworkSetting.prototype._Lan1WriteIP_(Return["Input"][0]);
			NetworkSetting.prototype._Lan1WriteMask_(Return["Input"][1]);
			NetworkSetting.prototype._Lan1WriteGateway_(Return["Input"][2]);
			Global_NetworkSetting["Lan1"]["Status"]=Return["Input"][4];
		
		}
		
	},500);
};

NetworkSetting.prototype._SetLan1NetworkSetting_ = function(that)
{
	var Lan1_SetIPv4 = $("#Lan1NetworkSetting").find("input[type=radio]")[0].checked;
	var Lan1_DHCP = $("#Lan1NetworkSetting").find("input[type=radio]")[1].checked;

	if(Lan1_SetIPv4 == true)
	{
		Global_NetworkSetting["Lan1"]["ConnectionMode"] = "static";
		NetworkSetting.prototype._SetLan1Ipv4StaticIp_(that);
	}
	else if(Lan1_DHCP == true)
	{
		Global_NetworkSetting["Lan1"]["ConnectionMode"] = "dhcp";
		NetworkSetting.prototype._SetLan1Dhcp_(that);
	}
};

NetworkSetting.prototype._SetLan1Ipv4StaticIp_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._Lan1AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	NetworkSetting.prototype._TransmissionLan1StaticIpAllData_(that);
};

NetworkSetting.prototype._SetLan1Dhcp_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	var ssocket = io.connect();
	NetworkSetting.prototype._TransmissionLan1Dhcp_(that, ssocket);
};

NetworkSetting.prototype._TransmissionLan1StaticIpAllData_ = function(that)
{
	var array = NetworkSetting.prototype._CollectLan1AllData_();
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("Lan1_SetIpv4StaticIp", array, Return);

	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			 
		}
		if(Return["Input"] == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
			
		}
		else if(Return["Input"] == false)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(2).show();
		}
	}, 500);
	NetworkSetting.prototype._TransferIpAddress_(that, array[0],"Lan1");
};

NetworkSetting.prototype._TransferIpAddress_ = function(that, IpAddress,Source)
{
	var OriginIP=Global_NetworkSetting[Source]["IPv4"]["IP"];
	if(document.location.hostname == OriginIP)
	{
		Global_ChangeIP = true;
		var Class = new Cgi();
		Class.LoginStatus("Delete", false);
		$(that).closest('.Form').find(".Message").eq(1).show();
		var TimeSetInterval = setInterval(function()
		{
			document.location.href = document.location.protocol+"//"+IpAddress;
			clearInterval(TimeSetInterval);
		}, 1500);
	}
	
};

NetworkSetting.prototype._TransmissionLan1Dhcp_ = function(that, ssocket)
{
	ssocket.emit('Lan1_SetDhcp');
	ssocket.on('Lan1_SetDhcp', function (Return) {
		if(Return == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(1).show();
		}
		ssocket.emit("SocketClose");
	});
};

NetworkSetting.prototype._Lan1AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#Lan1NetworkSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#Lan1NetworkSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};

NetworkSetting.prototype._CollectLan1AllData_ = function()
{
	var IP = NetworkSetting.prototype._Lan1ReadIP_();
	var Mask = NetworkSetting.prototype._Lan1ReadMask_();
	var Gateway = NetworkSetting.prototype._Lan1ReadGateway_();
	var Return = new Array(IP, Mask, Gateway);
	return Return;
};

NetworkSetting.prototype._Lan1ReadIP_ = function()
{
	var Return = "";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan1ReadMask_ = function()
{
	var Return = "";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan1ReadGateway_ = function()
{
	var Return = "";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan1WriteIP_ = function(IP)
{
	IP = IP.split(".");
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val(IP[0]);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).val(IP[1]);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).val(IP[2]);
	$("#Lan1NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).val(IP[3]);
};

NetworkSetting.prototype._Lan1WriteMask_ = function(Mask)
{
	Mask = Mask.split(".");
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val(Mask[0]);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).val(Mask[1]);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).val(Mask[2]);
	$("#Lan1NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).val(Mask[3]);
};

NetworkSetting.prototype._Lan1WriteGateway_ = function(Gateway)
{
	Gateway = Gateway.split(".");
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val(Gateway[0]);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).val(Gateway[1]);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).val(Gateway[2]);
	$("#Lan1NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).val(Gateway[3]);
};



NetworkSetting.prototype._GetLan2Ipv4Ip_ = function(Result)
{
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("Lan2_GetIpv4Ip", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			  
			Result["Input"] = true;
		}
		if(Array.isArray(Return["Input"]) == true && Return["Input"].length != 0)
		{
			Global_NetworkSetting["Lan2"]["IPv4"]["IP"]=Return["Input"][0];
			Global_NetworkSetting["Lan2"]["IPv4"]["Mask"]=Return["Input"][1];
			Global_NetworkSetting["Lan2"]["IPv4"]["Gateway"]=Return["Input"][2];
			Global_NetworkSetting["Lan2"]["ConnectionMode"]=Return["Input"][3];
			Global_NetworkSetting["Lan2"]["Status"]=Return["Input"][4];
			NetworkSetting.prototype._Lan2WriteIP_(Return["Input"][0]);
			NetworkSetting.prototype._Lan2WriteMask_(Return["Input"][1]);
			NetworkSetting.prototype._Lan2WriteGateway_(Return["Input"][2]);
	
		}
	
	},500);
};

NetworkSetting.prototype._SetLan2NetworkSetting_ = function(that)
{
	
	var Lan2_SetIPv4 = $("#Lan2NetworkSetting").find("input[type=radio]")[0].checked;
	var Lan2_DHCP = $("#Lan2NetworkSetting").find("input[type=radio]")[1].checked;
	if(Lan2_SetIPv4 == true)
	{
		NetworkSetting.prototype._SetLan2Ipv4StaticIp_(that);
	}else if ( Lan2_DHCP==true)
	{
		Global_NetworkSetting["Lan2"]["ConnectionMode"] = "dhcp";
		NetworkSetting.prototype._SetLan2Dhcp_(that);
	}

	
};

NetworkSetting.prototype._SetLan2Ipv4StaticIp_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();
	//判斷資料是否正確
	if(NetworkSetting.prototype._Lan2AllDataIsCorrect_() == false)
	{
		$(that).closest('.Form').find(".Loading").hide();
		$(that).closest('.Form').find(".Message").eq(3).show();
		return 0;
	}
	NetworkSetting.prototype._TransmissionLan2StaticIpAllData_(that);
	
};

NetworkSetting.prototype._SetLan2Dhcp_ = function(that)
{
	$(that).closest('.Form').find(".Message").hide();
	$(that).closest('.Form').find(".Loading").show();

	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("Lan2_SetDhcp", new Array(), Return);
	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			  
		}
		if(Return["Input"] == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
		}
	},500);
};

NetworkSetting.prototype._TransmissionLan2StaticIpAllData_ = function(that)
{
	
	var array = NetworkSetting.prototype._CollectLan2AllData_();
	var Return={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("Lan2_SetIpv4StaticIp", array, Return);

	var SetInterval = setInterval(function()
	{
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			 
		}
		if(Return["Input"] == true)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(0).show();
			
		}
		else if(Return["Input"] == false)
		{
			$(that).closest('.Form').find(".Loading").hide();
			$(that).closest('.Form').find(".Message").eq(2).show();
		}
	}, 500);
	NetworkSetting.prototype._TransferIpAddress_(that, array[0],"Lan2");
};

NetworkSetting.prototype._Lan2AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#Lan2NetworkSetting").find(".Row").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#Lan2NetworkSetting").find(".Row").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
};

NetworkSetting.prototype._CollectLan2AllData_ = function()
{
	var IP = NetworkSetting.prototype._Lan2ReadIP_();
	var Mask = NetworkSetting.prototype._Lan2ReadMask_();
	var Gateway = NetworkSetting.prototype._Lan2ReadGateway_();
	var Return = new Array(IP, Mask, Gateway);
	return Return;
};

NetworkSetting.prototype._Lan2ReadIP_ = function()
{
	var Return = "";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan2ReadMask_ = function()
{
	var Return = "";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan2ReadGateway_ = function()
{
	var Return = "";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).val() + ".";
	Return = Return + $("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).val();
	return Return;
};

NetworkSetting.prototype._Lan2WriteIP_ = function(IP)
{
	IP = IP.split(".");
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(0).val(IP[0]);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(1).val(IP[1]);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(2).val(IP[2]);
	$("#Lan2NetworkSetting").find(".Row").eq(1).find(".Text").eq(3).val(IP[3]);
};

NetworkSetting.prototype._Lan2WriteMask_ = function(Mask)
{
	Mask = Mask.split(".");
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(0).val(Mask[0]);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(1).val(Mask[1]);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(2).val(Mask[2]);
	$("#Lan2NetworkSetting").find(".Row").eq(2).find(".Text").eq(3).val(Mask[3]);
};

NetworkSetting.prototype._Lan2WriteGateway_ = function(Gateway)
{
	Gateway = Gateway.split(".");
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(0).val(Gateway[0]);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(1).val(Gateway[1]);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(2).val(Gateway[2]);
	$("#Lan2NetworkSetting").find(".Row").eq(3).find(".Text").eq(3).val(Gateway[3]);
};

NetworkSetting.prototype._SetIPv4RadioButton_ = function()
{
	var Lan1ConnectionMode = Global_NetworkSetting["Lan1"]["ConnectionMode"];
	var Lan2ConnectionMode = Global_NetworkSetting["Lan2"]["ConnectionMode"];
	
	var Form = $("#Main_Center-Content").find(".Form");
    switch(Lan1ConnectionMode)
	{
		case 'static': Form.eq(0).find(":radio").get(0).checked = true; break;
		case 'dhcp': Form.eq(0).find(":radio").get(1).checked = true; break;
		default:
	}
  
};

NetworkSetting.prototype._GetIPv4Setting_ = function(Result)
{
	var Result_1={"Input":null};  var Result_2={"Input":null};

	//NetworkSetting.prototype._SetIPv4RadioButton_();
	NetworkSetting.prototype._GetLan1Ipv4Ip_(Result_1);
	NetworkSetting.prototype._GetLan2Ipv4Ip_(Result_2);

	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval);
		}
	},500);
}

NetworkSetting.prototype._SetConnectionMode_ = function()
{
	var Result_1={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SetNetworkConnectionMode", JSON.stringify(Global_NetworkSettingVariable), Result_1);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval);
		}
	},500);
}

NetworkSetting.prototype._GetOpenVPNClientStatus_ = function(Result) {
    //var Return = {"status": false, "IP": null, "username": null, "password": null, "profileFile": null};
    var Return ={Input:null};
	var Class = new Transmission();
    Class.TransmissionArray("GetOpenVPNClientStatus", [], Return);
  
    var SetInterval = setInterval(function() {
        if (Return["Input"] !== null ) 
		{
            Result["Input"] = Return["Input"];
            //Result["IP"] = Return["Input"].IP;
            //Result["status"] = Return["Input"].status;
            
            if (Return["Input"].username !== null) {
                $("#OpenVPNUsername").val(Return["Input"].username);
            } else {
                $("#OpenVPNUsername").val("");
            }

            if (Return["Input"].password !== null) {
                $("#OpenVPNPassword").val(Return["Input"].password);
            } else {
                $("#OpenVPNPassword").val("");
            }

            if (Return["Input"].IP !== null) {
                $("#OpenVPNIP").text(Return["Input"].IP);
            } else {
                $("#OpenVPNIP").text("");
            }

            if (Return["Input"].status === true) {
                $("#OpenVPNIsEnable").prop("checked", true);
            } else {
                $("#OpenVPNIsEnable").prop("checked", false);
            }

            if (Result["Input"].profileFile !== null) {
                $("#OpenVPNProfileFile").val(Return["Input"].profileFile);
            } else {
                $("#OpenVPNProfileFile").val("");
            }

            clearInterval(SetInterval);
        }
    }, 500);
}



NetworkSetting.prototype._SetOpenVPNClientStatus_ = function(status, Result) 
{
    var Return = {"Input": null};
    var Class = new Transmission();
    Class.TransmissionArray("SetOpenVPNClientStatus", [status], Return);
  
    var SetInterval = setInterval(function() {
        if (Return["Input"]!== null) {
            Result["status"] = Return["Input"].status;
            
            if (Return["Input"].status === true) {
                $("#OpenVPNIsEnable").prop("checked", true);
                requestOpenVPNIP();
            } else {
                $("#OpenVPNIsEnable").prop("checked", false);
                $("#OpenVPNIP").text("");
            }

            clearInterval(SetInterval);
        }
    }, 500);
}


NetworkSetting.prototype._UploadOpenVPNProfile_ = function() {
    var fileInput = $('#OpenVPNFileInput')[0];
    var file = fileInput.files[0];
    
    if (file) {
        var fileName = file.name.toLowerCase();
        if (fileName.endsWith('.conf')) {
            var socket = io.connect();
            var stream = ss.createStream();
            ss(socket).emit('UploadOpenVPNProfile', stream, { name: file.name });
            ss.createBlobReadStream(file).pipe(stream);

            socket.on('UploadOpenVPNProfile', function(success) {
                if (success) {
                    $('#OpenVPNProfileFile').val(file.name);
                    //console.log('File uploaded successfully:', file.name);
                } else {
                    //console.log('File upload failed');
                }
            });
        } else {
            //console.log('Invalid file type. Please select a .conf file.');
        }
    } else {
       // console.log('No file selected');
    }
};

NetworkSetting.prototype._SetOpenVPNClientSetting_ = function(that) {
    var username = $("#OpenVPNUsername").val();
    var password = $("#OpenVPNPassword").val();
    var Result = {"Input": null};

    var $parent = $(that).closest('.Row').find('.RightColumn');

    $parent.find(".Loading").show();
    $parent.find(".Message").hide();

    var Class = new Transmission();
    Class.TransmissionArray("SetOpenVPNClientSetting", [username, password], Result);

    var SetInterval = setInterval(function() {
        if (Result.Input !== null) {
            $parent.find(".Loading").hide();
            if (Result.Input === true) {
                $parent.find(".Message.Success").show();
             
                requestOpenVPNIP($parent);
            } else {
                $parent.find(".Message.Failure").show();
            }
            clearInterval(SetInterval);
        }
    }, 500);
}

function requestOpenVPNIP($parent) {
    var socket = io.connect();
    var checkInterval = setInterval(function() {
     
        if ($("#OpenVPNIP").length === 0) {
            clearInterval(checkInterval);
            return;
        }

        socket.emit('GetOpenVPNIP');
        socket.on('GetOpenVPNIP', function(data) {
            if (data.IP && data.IP !== "") {
                $("#OpenVPNIP").text(data.IP);
                clearInterval(checkInterval);
            } else {
                //console.log('VPN IP not available yet.');
            }
        });
    }, 1000); 
}
