MqttToSpeakStepFlow.prototype._SelectComPortSetting_ = function(that)
{
	var TopMenuId="Top-Menu-SystemSetting", LeftListId="Left-List-ComPortSetting";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};
MqttToSpeakStepFlow.prototype._ClickElement_ = function(that, TopMenuId, LeftListId)
{
	$("#Main_Top-Menu").find("#"+TopMenuId).click();
	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("#"+LeftListId).click();
	StepFlow.prototype._ChangeDivCss_(that);
	$("#Main_Top-Path").find("div").css('pointer-events', "visible");
	$("#Main_Top-Menu").find("div").css('pointer-events', "visible");
	$("#Main_Left-List").find("div").css('pointer-events', "visible");

	if (TopMenuId == "Top-Menu-ModuleSetting") 
	{
    	$('span:contains("MQTT")').css("display", "none");
    	$("#Left-List-MQTT").css("display", "none");
    	$("#Left-List-MQTT").next("br").remove();
    }


};
MqttToSpeakStepFlow.prototype._DisableElement_ = function(TopMenuId, LeftListId)
{
	MqttToSpeakStepFlow.prototype._StopFingerIcon_();
	$("#Main_Top-Path").find("div").css('pointer-events', "none");
	$("#Main_Top-Path").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("div").css('pointer-events', "none");
	$("#Main_Top-Menu").find("div").css('opacity', 0.5);

	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("#"+TopMenuId).css('opacity', 1);
	$("#Main_Left-List").find("#"+LeftListId).css('opacity', 1);
};

MqttToSpeakStepFlow.prototype._StopFingerIcon_ = function()
{
	clearInterval(Global_SetInterval);
	var Column = $("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").find(".Column");
	Column.eq(1).hide();
	Column.eq(2).find(".Select").css("border-color", "#AAAAAA");
	Column.eq(2).find(".Select").css("border-width", "1px");
};

MqttToSpeakStepFlow.prototype._UnlockAllModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-RTU";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._StopFingerIcon_();

	$("#Main_Top-Menu").find("div").css('pointer-events', "none");
	$("#Main_Top-Menu").find("div").css('opacity', 0.5);

	$("#Main_Top-Path").find("div").css('pointer-events', "none");
	$("#Main_Top-Path").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("#"+TopMenuId).css('opacity', 1);
};
MqttToSpeakStepFlow.prototype._SelectMqttCertificate_ = function(that)
{
	var TopMenuId="Top-Menu-File", LeftListId="Left-List-MqttCertificate";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

MqttToSpeakStepFlow.prototype._SelectBrokerSetting_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-LocalBroker";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	$("#Main_Left-List").find("#Left-List-LocalBroker").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-LocalBroker").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-RemoteBroker").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-RemoteBroker").css('opacity', 1);
};

MqttToSpeakStepFlow.prototype._SelectMqttGroupConnection_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-MqttJsonGroup";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

MqttToSpeakStepFlow.prototype._MqttToIoTCloud_ = function(that)
{
	var Class = new MqttToIoTCloudUpdatePage();
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-MqttToIoTCloud";
	MqttToSpeakStepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	MqttToSpeakStepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};



StepFlowMqttToIoTCloud.prototype._RunProject_ = function(that)
{
	$(that).closest('.Column').find(".Message").eq(1).show();
	StepFlowMqttToIoTCloud.prototype._RunMainProgram_(that);
	StepFlowMqttToIoTCloud.prototype._RunMqttBroker_();
};

StepFlowMqttToIoTCloud.prototype._RunMainProgram_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StartMainSystem');
	ssocket.on('StartMainSystem', function (Return) {
		if(Return == true)
		{
			ssocket.emit("SocketClose");
			$(that).closest('.Column').find(".Message").hide();
			$(that).closest('.Column').find(".Message").eq(0).show();
			var SetInterval = setInterval(function()
			{
				$("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").eq(0).find(".Select").val("null");
				StepFlowMqttToIoTCloud.prototype._AllEnableElement_();
				$("#Main_Top-StepFlow").find(".StepTable").hide();
				$(that).closest('.Column').find(".Message").hide();
				clearInterval(SetInterval);
			},2500);
		}
		else
		{
			ssocket.emit('StartMainSystem');
		}
	});
};
StepFlowMqttToIoTCloud.prototype._RunMqttBroker_ = function()
{
	var ssocket = io.connect();
	ssocket.emit('StartMqttBroker');
	ssocket.on('StartMqttBroker', function (Return) 
	{
		if(Return == true)
		{
			ssocket.emit("SocketClose");
		}
		else
		{
			ssocket.emit('StartMqttBroker');
		}
	});
};

StepFlowMqttToIoTCloud.prototype._AllEnableElement_ = function()
{
	$("#Main_Top-Path").find("div").css('pointer-events', "visible");
	$("#Main_Top-Path").find("div").css('opacity', 1);
	
	$("#Main_Top-Menu").find("div").css('pointer-events', "visible");
	$("#Main_Top-Menu").find("div").css('opacity', 1);
	
	$("#Main_Left-List").find("div").css('pointer-events', "visible");
	$("#Main_Left-List").find("div").css('opacity', 1);
};

StepFlowMqttToIoTCloud.prototype._SaveXml_ = async function(that) 
{
    const Class = new ControllerServiceSetting();
    const Result_1 = { "Input": null };
    const Result_2 = { "Input": null };

    await Promise.all([
        Class._SaveDeviceDri_(Result_1),
        Class._SaveServiceXml_(Result_2)
    ]);

    const waitForResults = () => {
        return new Promise((resolve) => {
            const interval = setInterval(() => {
                if (Result_1.Input === true && Result_2.Input === true) {
                    clearInterval(interval);
                    resolve();
                }
            }, 100);
        });
    };

    await waitForResults();

    if (Result_1.Input === true && Result_2.Input === true) {
        $(that).closest('.Row').find(".BigLoading").hide();
        const StepFlowClass = new StepFlow();
        StepFlowClass.UnLockAllUi(that);
    }
};




StepFlowMqttToIoTCloud.prototype._SaveMqttToIoTCloud_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StopMainSystem');
	ssocket.on('StopMainSystem', function (Return) {
		if(Return == true)
		{
			var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};
			var Result_5={"Input":null}, Result_6={"Input":null}, Result_7={"Input":null};
			var Class_1 = new Transmission();
			Class_1.TransmissionArray("SaveAzurePlatformSetting", new Array(Global_AzurePlatform), Result_1);
			Class_1.TransmissionArray("SaveLocalBrokerSetting", Global_LocalBroker, Result_2);
			Class_1.TransmissionArray("SaveRemoteBrokerSetting", new Array(Global_RemoteBroker), Result_3);
			Class_1.TransmissionString("SaveRemoteMqttGroup", JSON.stringify(Global_RemoteMqttGroup), Result_4);
			Class_1.TransmissionString("SaveComPortSetting", JSON.stringify(Global_ComPort), Result_5);
			Class_1.TransmissionString("SaveMqttJsonGroup", JSON.stringify(Global_MqttJsonGroup), Result_6);
			var Class_2 = new RtuModuleFirstPage();
			Class_2.SaveDataLayerAndServiceLayerVariables(Result_7);
		
			var SetInterval = setInterval(function()
			{
				if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true && Result_4["Input"]==true && 
					Result_5["Input"]==true && Result_6["Input"]==true && Result_7["Input"]==true)
				{
					Class_1 = null;  delete Class_1;
					Class_2 = null;  delete Class_2;
					StepFlowMqttToIoTCloud.prototype._SaveXml_(that);
					clearInterval(SetInterval);
				}
			},500);
			}
		else if(Return == false)
		{
		}
		ssocket.emit("SocketClose");
	})
	

};

MqttToOpcuaStepFlow.prototype._SaveXml_ = async function(that) {
    const Class = new ControllerServiceSetting();
    const Result_1 = { "Input": null };
    const Result_2 = { "Input": null };

    await Promise.all([
        Class._SaveDeviceDri_(Result_1),
        Class._SaveServiceXml_(Result_2)
    ]);

    const waitForResults = () => {
        return new Promise((resolve) => {
            const interval = setInterval(() => {
                if (Result_1.Input === true && Result_2.Input === true) {
                    clearInterval(interval);
                    resolve();
                }
            }, 100);
        });
    };

    await waitForResults();

    if (Result_1.Input === true && Result_2.Input === true) {
        $(that).closest('.Row').find(".BigLoading").hide();
        const StepFlowClass = new StepFlow();
        StepFlowClass.UnLockAllUi(that);
    }
};


/* MqttToOpcuaStepFlow.prototype._SaveXml_ = async function(that)
{
	var Class = new ControllerServiceSetting();
	var Result_1={"Input":null}, Result_2={"Input":null};
	const [Result_1, Result_2] = await Promise.all([
        Class.SaveDeviceDri({}),
        Class.SaveServiceXml({})
    ]);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true)
		{
			  
			$(that).closest('.Row').find(".BigLoading").hide();
			var StepFlowClass = new StepFlow();
			StepFlowClass.UnLockAllUi();
			clearInterval(SetInterval);
		}
	},500);
}; */


MqttToOpcuaStepFlow.prototype._SaveMqttToOpcua_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StopMainSystem');
	ssocket.on('StopMainSystem', function (Return) {
	if(Return == true)
	{
			var xotree = new XML.ObjTree();
			var OpcUaLocalServerXml = xotree.writeXML(Global_OpcUaLocalServer);

			var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};

			var Class_1 = new Transmission();
			Class_1.TransmissionArray("SaveLocalBrokerSetting", Global_LocalBroker, Result_1);
			Class_1.TransmissionArray("SaveRemoteBrokerSetting", new Array(Global_RemoteBroker), Result_2);
			Class_1.TransmissionArray("SaveOpcUaLocalServer", new Array(OpcUaLocalServerXml), Result_3);

			var Class_2 = new MqttModuleFirstPage();
			Class_2.SaveDataLayerAndServiceLayerVariables(Result_4);
			var SetInterval = setInterval(function()
			{
				if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true && Result_4["Input"]==true)
				{
					Class_1 = null;  delete Class_1;
					Class_2 = null;  delete Class_2;
					ModbusToOpcuaStepFlow.prototype._SaveXml_(that);
					clearInterval(SetInterval);
				}
			},500);
		}
		else if(Return == false)
		{
		}
		ssocket.emit("SocketClose");
	})
	
};
