MqttToMysqlStepFlow.prototype._SaveXml_ = async function(that) 
{
    var Class = new ControllerServiceSetting();
    var Result_1 = {"Input": null};
    var Result_2 = {"Input": null};

    await Promise.all([
        Class.SaveDeviceDri(Result_1),
        Class.SaveServiceXml(Result_2)
    ]);

    if (Result_1["Input"] === true && Result_2["Input"] === true) {
        $(that).closest('.Row').find(".BigLoading").hide();
        var StepFlowClass = new StepFlow();
        StepFlowClass.UnLockAllUi();
    } else {
        //console.error("Conditions not met: Result_1 or Result_2 Input is not true");
    }
};
/*
MqttToMysqlStepFlow.prototype._SaveMqttToMysql_ = async function(that) 
{
    var ssocket = io.connect();
    ssocket.emit('StopMainSystem');
	const wrapInPromise = (method, ...args) => {
		return new Promise((resolve) => {
			method(...args, (result) => resolve(result));
		});
	};
    ssocket.on('StopMainSystem', async function(Return) {
        if (Return == true) {
            var Class_1 = new MqttModuleFirstPage();
            var Class_2 = new MysqlConnectionFirstPage();

            const [Result_1, Result_2] = await Promise.all([
                wrapInPromise(Class_1.SaveDataLayerAndServiceLayerVariables, {}),
                wrapInPromise(Class_2.SaveMysqlConnectionSetting, {})
            ]);

            if (Result_1.Input === true && Result_2.Input === true) {
                Class_1 = null; delete Class_1;
                Class_2 = null; delete Class_2;
                MqttToMysqlStepFlow.prototype._SaveXml_(that);
            } else {
                //console.error("Conditions not met: Result_1 or Result_2 Input is not true");
            }
        } else if (Return == false) {
            // Handle the case where Return is false
        }
        // ssocket.emit("SocketClose");
    });
};
*/
MqttToMysqlStepFlow.prototype._SaveMqttToMysql_ = function(that)
{
	
	var ssocket = io.connect();
	ssocket.emit('StopMainSystem');
	ssocket.on('StopMainSystem', function (Return) {
		if(Return == true)
		{
			var Result_1={"Input":null}, Result_2={"Input":null};
			var Class_1 = new MqttModuleFirstPage();
			Class_1.SaveDataLayerAndServiceLayerVariables(Result_1);

			var Class_2 = new MysqlConnectionFirstPage();
			Class_2.SaveMysqlConnectionSetting(Result_2);

			var SetInterval = setInterval(function()
			{
				if(Result_1["Input"]==true && Result_2["Input"]==true)
				{
					Class_1 = null;  delete Class_1;
					Class_2 = null;  delete Class_2;
					MqttToMysqlStepFlow.prototype._SaveXml_(that);
					clearInterval(SetInterval);
				}
			},500); 
		}
		else if(Return == false)
		{
		}
		ssocket.emit("SocketClose");
	})
	
}; 

MqttToMsSqlStepFlow.prototype._SaveXml_ = async function(that) 
{
    const Class = new ControllerServiceSetting();
    const Result_1 = { "Input": null };
    const Result_2 = { "Input": null };

    await Promise.all([
        Class.SaveDeviceDri(Result_1),
        Class.SaveServiceXml(Result_2)
    ]);

    const waitForResults = () => {
        return new Promise((resolve) => {
            const interval = setInterval(() => {
                if (Result_1.Input === true && Result_2.Input === true) {
                    clearInterval(interval);
                    resolve();
                }
            }, 100);
        });
    };

    await waitForResults();
    $(that).closest('.Row').find(".BigLoading").hide();
    new StepFlow().UnLockAllUi();
};



/* MqttToMsSqlStepFlow.prototype._SaveXml_ = async function(that)
{
	var Class = new ControllerServiceSetting();
	var Result_1={"Input":null}, Result_2={"Input":null};
	Class.SaveDeviceDri(Result_1);
	Class.SaveServiceXml(Result_2);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true)
		{
			  
			$(that).closest('.Row').find(".BigLoading").hide();
			var StepFlowClass = new StepFlow();
			StepFlowClass.UnLockAllUi();
			clearInterval(SetInterval);
		}
	},500);
};*/
/* MqttToMsSqlStepFlow.prototype._SaveMqttToMsSql_ = async function(that) 
{
    var ssocket = io.connect();
    ssocket.emit('StopMainSystem');
	const wrapInPromise = (method, ...args) => {
		return new Promise((resolve) => {
			method(...args, (result) => resolve(result));
		});
	};
    ssocket.on('StopMainSystem', async function(Return) {
        if (Return == true) {
            var Class_1 = new MqttModuleFirstPage();
            var Class_2 = new MysqlConnectionFirstPage();

            const [Result_1, Result_2] = await Promise.all([
                wrapInPromise(Class_1.SaveDataLayerAndServiceLayerVariables, {}),
                wrapInPromise(Class_2.SaveMysqlConnectionSetting, {})
            ]);

            if (Result_1.Input === true && Result_2.Input === true) {
                //Class_1 = null; delete Class_1;
                //Class_2 = null; delete Class_2;
                MqttToMsSqlStepFlow.prototype._SaveXml_(that);
            } else {
                //console.error("Conditions not met: Result_1 or Result_2 Input is not true");
            }
        } else if (Return == false) {
            // Handle the case where Return is false
        }
        // ssocket.emit("SocketClose");
    });
}; */

MqttToMsSqlStepFlow.prototype._SaveMqttToMsSql_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StopMainSystem');
	ssocket.on('StopMainSystem', function (Return) {
		if(Return == true)
		{
			var Result_1={"Input":null}, Result_2={"Input":null};
			var Class_1 = new MqttModuleFirstPage();
			Class_1.SaveDataLayerAndServiceLayerVariables(Result_1);

			var Class_2 = new MysqlConnectionFirstPage();
			Class_2.SaveMysqlConnectionSetting(Result_2);

			var SetInterval = setInterval(function()
			{
				if(Result_1["Input"]==true && Result_2["Input"]==true)
				{
					//Class_1 = null;  delete Class_1;
					//Class_2 = null;  delete Class_2;
					MqttToMsSqlStepFlow.prototype._SaveXml_(that);
					clearInterval(SetInterval);
				}
			},500); 	
		}
		else if(Return == false)
		{
		}
		ssocket.emit("SocketClose");
	})
	
}; 