WebSecure.prototype._ShowUi_ = function () {
	var Row = $("#Main_Center-Content").find(".Form").eq(0).find(".Row");

	Row.eq(0).find(".Checkbox").prop("checked", Global_WebSecure["Connection"]["Http"]);
	Row.eq(1).find(".Checkbox").prop("checked", Global_WebSecure["Connection"]["Https"]);

	if (Global_WebSecure["Connection"]["Https"] == true) {
		Row.eq(2).show();
		Row.eq(3).show();
		Row.eq(4).show();
	}
};

WebSecure.prototype._FileTransmission_ = function (that, file) {
	var ssocket = io.connect();
	var stream = ss.createStream();
	var blobStream = ss.createBlobReadStream(file);

	blobStream.on('data', function (chunk) {
		//console.log('data chunk.length:', chunk.length);
	});
	blobStream.on('end', function () {
		$(that).closest(".Row").find(".Loading").eq(0).hide();
		$(that).closest("div").find(":file").val("");
	});

	blobStream.pipe(stream);
	ss(ssocket).emit('UploadFile', stream, { name: file.name });
};

WebSecure.prototype._CheckCertificateFileName_ = function (that, FileName) {
	var Return = true;
	if (!(FileName.indexOf(".pem") != -1 ||
		FileName.indexOf(".der") != -1 ||
		FileName.indexOf(".crt") != -1)) {
		$(that).closest(".Row").find(".Loading").hide();
		$(that).closest(".Row").find(".Message").eq(1).show();
		Return = false;
		return Return;
	}
	$(that).closest(".Row").find(".Message").hide();
	return Return;
};

WebSecure.prototype._CheckPrivateKeyFileName_ = function (that, FileName) {
	var Return = true;
	if (!(FileName.indexOf(".key") != -1)) {
		$(that).closest(".Row").find(".Loading").hide();
		$(that).closest(".Row").find(".Message").eq(1).show();
		Return = false;
		return Return;
	}
	$(that).closest(".Row").find(".Message").hide();
	return Return;
};

WebSecure.prototype._UploadCertificateFile_ = function (that, Event) {
	var file = Event.target.files[0];
	if (file == null) { return 0; }

	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Loading").eq(0).show();
	var FileName = file.name;
	$(that).closest("div").find(":text").val(file.name);
	if (WebSecure.prototype._CheckCertificateFileName_(that, FileName) == false) { return 0; }
	WebSecure.prototype._FileTransmission_(that, file);
	Global_WebSecure["Connection"]["cert"] = FileName;
};

WebSecure.prototype._UploadPrivateKey_ = function (that, Event) {
	var file = Event.target.files[0];
	if (file == null) { return 0; }

	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Loading").eq(0).show();
	var FileName = file.name;
	$(that).closest("div").find(":text").val(file.name);
	if (WebSecure.prototype._CheckPrivateKeyFileName_(that, FileName) == false) { return 0; }
	WebSecure.prototype._FileTransmission_(that, file);
	Global_WebSecure["Connection"]["key"] = FileName;
};

WebSecure.prototype._UpdateCertificate_ = function (that) {
	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Loading").eq(1).show();
	FileName = $(that).closest("div").find(":text").val();
	$(that).closest("div").find(":text").val("");
	var ssocket = io.connect();
	ssocket.emit("UpdateHttpsCertificate", FileName);
	ssocket.on("UpdateHttpsCertificate", function (Return) {
		if (Return == true) {
			$(that).closest(".Row").find(".Loading").hide();
			$(that).closest(".Row").find(".Message").eq(3).show();
		}
		else {
			$(that).closest(".Row").find(".Loading").hide();
			$(that).closest(".Row").find(".Message").eq(4).show();
		}
		ssocket.emit("SocketClose");
	});
};

WebSecure.prototype._UpdatePrivateKey_ = function (that) {
	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Loading").eq(1).show();
	FileName = $(that).closest("div").find(":text").val();
	$(that).closest("div").find(":text").val("");
	var ssocket = io.connect();
	ssocket.emit("UpdateHttpsPrivateKey", FileName);
	ssocket.on("UpdateHttpsPrivateKey", function (Return) {
		if (Return == true) {
			$(that).closest(".Row").find(".Loading").hide();
			$(that).closest(".Row").find(".Message").eq(3).show();
		}
		else {
			$(that).closest(".Row").find(".Loading").hide();
			$(that).closest(".Row").find(".Message").eq(4).show();
		}
		ssocket.emit("SocketClose");
	});
};

WebSecure.prototype._ChangeHttp_ = function (that) {
	var Row = $(that).closest(".Form").find(".Row");
	var HttpEnbale = Row.eq(0).find(":checkbox").prop("checked");
	var HttpsEnbale = Row.eq(1).find(":checkbox").prop("checked");

	if ((HttpEnbale == false) && (HttpsEnbale == false)) {
		Row.eq(0).find(":checkbox").prop("checked", true);
		HttpEnbale = true;
	}
};

WebSecure.prototype._ChangeHttpsCss_ = function (that) {
	var Row = $(that).closest(".Form").find(".Row");
	var HttpEnbale = Row.eq(0).find(":checkbox").prop("checked");
	var HttpsEnbale = Row.eq(1).find(":checkbox").prop("checked");
	var HttpsPort = Row.eq(2);
	var HttpsCertificateRow = Row.eq(3);
	var HttpsPrivateKeyRow = Row.eq(4);

	if ((HttpEnbale == false) && (HttpsEnbale == false)) {
		Row.eq(1).find(":checkbox").prop("checked", true);
		HttpsEnbale = true;
	}

	if (HttpsEnbale == true) {
		HttpsPort.show();
		HttpsCertificateRow.show();
		HttpsPrivateKeyRow.show();
	}
	else if (HttpsEnbale == false) {
		HttpsPort.hide();
		HttpsCertificateRow.hide();
		HttpsPrivateKeyRow.hide();
	}
};

WebSecure.prototype._GetCheckBoxValue_ = function (that) {
	var CheckBox = $("#Main_Center-Content").find(".Form").eq(0).find(".Row").find(".Checkbox");

	Global_WebSecure["Connection"]["Http"] = CheckBox.eq(0).prop("checked");
	Global_WebSecure["Connection"]["Https"] = CheckBox.eq(1).prop("checked");
};



WebSecure.prototype._SaveWebSecure_ = function (Result) {
	var Result_1 = { "Input": null };
	var Class = new Transmission();
	Class.TransmissionString("SaveWebSecure", JSON.stringify(Global_WebSecure), Result_1);
	var SetInterval = setInterval(function () {
		if (Result_1["Input"] == true) {
			Result["Input"] = true;
			clearInterval(SetInterval);
		}
	}, 500);
};

WebSecure.prototype._SaveButton_ = function (that) {
	var Result = { "Input": null };
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();
	WebSecure.prototype._GetCheckBoxValue_(that);
	WebSecure.prototype._SaveWebSecure_(Result);
	var SetInterval = setInterval(function () {
		if (Result["Input"] == true) {
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
			clearInterval(SetInterval);
		}
	}, 500);
};

function WhitelistChangeRuleType(select) {
	var ruleType = $(select).val();
	if (ruleType === 'single') {
		$('#singleIpRow').show();
		$('#ipRangeRow').hide();
	} else if (ruleType === 'range') {
		$('#singleIpRow').hide();
		$('#ipRangeRow').show();
	}
}

function CreateRow(ruleType, ruleValue) {
	var row = $('<div class="Row"></div>');
	row.append('<div class="TitleColumn" style="background-color: #F8F8F8;">' + ruleType + '</div>');
	row.append('<div class="TitleColumn" style="background-color: #F8F8F8;">' + ruleValue + '</div>');
	var deleteButton = $('<div class="TitleColumn" style="background-color: #F8F8F8;"><button>Delete</button></div>');
	deleteButton.click(function () {
		row.remove();
	});
	row.append(deleteButton);
	return row;
}

function GetWhitelist(that) {
	$('#LoadWhitelist').show();
	var ssocket = io.connect();
	ssocket.emit("GetWhitelist");
	ssocket.on("GetWhitelist", function (Return) {
		if (Return === false) {
			$('#LoadWhitelist').hide();
			let text = Global_TranslateJson["/html/Center/WebSecure.html___Unable to get settings"];
			$('#WhitelistError').text(text);
			$('#WhitelistError').show();
		} else {
			$('#WhitelistTable').find('.Row').slice(1).remove();
			$('#LoadWhitelist').hide();
			$('#WhitelistEdit').show();
			$('#WhitelistTable').show();
			$('#SubmitRule').show();
			let text = Global_TranslateJson["/html/Center/WebSecure.html___WhitelistHide"];
			$(that).val(text);

			clientIP = Return.clientIP;
			if (clientIP.includes("::ffff:")) {
				const potentialIPv4 = clientIP.split("::ffff:")[1];
				if (/(\d{1,3}\.){3}\d{1,3}/.test(potentialIPv4)) {
					clientIP = potentialIPv4;
				}
			}
			
			for (var i = 0; i < Return.whitelist.length; i++) {
				var ip = Return.whitelist[i];
				if (!ip) continue;
				var ruleType = ip.includes('to') ? 'range' : 'single';
				var row = CreateRow(ruleType, ip);
				$('#WhitelistTable').append(row);
			}
		}
		ssocket.emit("SocketClose");
	});
}

function isIPv4(ip) {
    return ip.split('.').length === 4;
}

function ipToNumber(ip) {
    return ip.split('.').reduce((acc, octet) => (acc << 8) + parseInt(octet, 10), 0) >>> 0;
}

function isIPv6InRange(ip, range) {
    var ip6 = require('ip6');
    var [startIP, endIP] = range.split(' to ');
    return ip6.isWithinRange(ip, startIP, endIP);
}

function isIPInRange(ip, range) {
    if (range.includes('to')) {
        if (isIPv4(ip)) {
            // IPv4 範圍檢查，假設範圍格式為 "startIP to endIP"
            var [startIP, endIP] = range.split(' to ');
            var ipNum = ipToNumber(ip);
            return ipToNumber(startIP) <= ipNum && ipNum <= ipToNumber(endIP);
        } else {
            // IPv6 範圍檢查
            return isIPv6InRange(ip, range);
        }
    } else {
        // 單個IP檢查
        return ip === range;
    }
}

function SetWhitelist(that) {
    $('#SubmitRuleMessage').hide();
    $('#LoadSubmitRule').show();
    var IPList = [];
    $('#WhitelistTable .Row').each(function (index) {
        if (index !== 0) {
            var ruleValue = $(this).find('.TitleColumn').eq(1).text();
            IPList.push(ruleValue);
        }
    });

    if (IPList.length > 0) {
        var isInWhitelist = IPList.some(range => isIPInRange(clientIP, range));

        if (!isInWhitelist) {
            let template = Global_TranslateJson["/html/Center/WebSecure.html___IPNotInWhitelist"];
            let text = template.replace("{clientIP}", clientIP);
            if (!confirm(text)) {
                $('#LoadSubmitRule').hide();
                return;
            }
        }
    }

    var ssocket = io.connect();
    ssocket.emit("SetWhitelist", IPList);
    ssocket.on("SetWhitelist", function (Return) {
        if (Return == true) {
            $('#LoadSubmitRule').hide();
            let text = Global_TranslateJson["/html/Center/WebSecure.html___Success"];
            $("#SubmitRuleMessage").css("color", "#227700");
            $('#SubmitRuleMessage').text(text);
            $('#SubmitRuleMessage').show();
        } else {
            $('#LoadSubmitRule').hide();
            let text = Global_TranslateJson["/html/Center/WebSecure.html___Failure"];
            $('#SubmitRuleMessage').text(text);
            $("#SubmitRuleMessage").css("color", "#FF0000");
            $('#SubmitRuleMessage').show();
        }
        ssocket.emit("SocketClose");
    });
}


function WhitelistValidateIpV4(ip) {
	var ipv4Pattern = /^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])$/;
	return ipv4Pattern.test(ip);
}

function WhitelistAddRule() 
{
	var ruleType = $('#ruleType').val();
	var ruleValue;
	if (ruleType === 'single') {
		var singleIp = $('#singleIpPart1').val() + '.' +
			$('#singleIpPart2').val() + '.' +
			$('#singleIpPart3').val() + '.' +
			$('#singleIpPart4').val();
		if (!WhitelistValidateIpV4(singleIp)) {
			let text = Global_TranslateJson["/html/Center/WebSecure.html___Invalid IP address"];
			alert(text);
			return;
		}
		ruleValue = singleIp;
	} else if (ruleType === 'range') {
		
		var rangeCount = $('#WhitelistTable .Row').filter(function () {
			return $(this).find('.TitleColumn').eq(0).text() === 'range';
		}).length;
		if (rangeCount >= 2) {
			let text = Global_TranslateJson["/html/Center/WebSecure.html___Range Rules Limit"];
			alert(text);
			return;
		}

		var ipStart = $('#ipStartPart1').val() + '.' +
			$('#ipStartPart2').val() + '.' +
			$('#ipStartPart3').val() + '.' +
			$('#ipStartPart4').val();
		var ipEnd = $('#ipEndPart1').val() + '.' +
			$('#ipEndPart2').val() + '.' +
			$('#ipEndPart3').val() + '.' +
			$('#ipEndPart4').val();

		if (!WhitelistValidateIpV4(ipStart) || !WhitelistValidateIpV4(ipEnd)) {
			let text = Global_TranslateJson["/html/Center/WebSecure.html___Invalid IP address"];
			alert(text);
			return;
		}
		var startNum = ipToNumber(ipStart);
		var endNum = ipToNumber(ipEnd);
		if (startNum > endNum) {
			let text = Global_TranslateJson["/html/Center/WebSecure.html___Invalid IP range"];
			alert(text);
			return;
		}

		ruleValue = ipStart + ' to ' + ipEnd;

	}

	var isDuplicate = $('#WhitelistTable .Row').is(function () {
		return $(this).text().indexOf(ruleValue) !== -1;
	});

	if (isDuplicate) {
		let text = Global_TranslateJson["/html/Center/WebSecure.html___Rule already exists"];
		alert(text);
	} else {
		var row = CreateRow(ruleType, ruleValue);
		$('#WhitelistTable').append(row);
	}
}
